/****************************************************************************
 * NCSA Mosaic for the X Window System                                      *
 * Software Development Group                                               *
 * National Center for Supercomputing Applications                          *
 * University of Illinois at Urbana-Champaign                               *
 * 605 E. Springfield, Champaign IL 61820                                   *
 * mosaic@ncsa.uiuc.edu                                                     *
 *                                                                          *
 * Copyright (C) 1993, Board of Trustees of the University of Illinois      *
 *                                                                          *
 * NCSA Mosaic software, both binary and source (hereafter, Software) is    *
 * copyrighted by The Board of Trustees of the University of Illinois       *
 * (UI), and ownership remains with the UI.                                 *
 *                                                                          *
 * The UI grants you (hereafter, Licensee) a license to use the Software    *
 * for academic, research and internal business purposes only, without a    *
 * fee.  Licensee may distribute the binary and source code (if released)   *
 * to third parties provided that the copyright notice and this statement   *
 * appears on all copies and that no charge is associated with such         *
 * copies.                                                                  *
 *                                                                          *
 * Licensee may make derivative works.  However, if Licensee distributes    *
 * any derivative work based on or derived from the Software, then          *
 * Licensee will (1) notify NCSA regarding its distribution of the          *
 * derivative work, and (2) clearly notify users that such derivative       *
 * work is a modified version and not the original NCSA Mosaic              *
 * distributed by the UI.                                                   *
 *                                                                          *
 * Any Licensee wishing to make commercial use of the Software should       *
 * contact the UI, c/o NCSA, to negotiate an appropriate license for such   *
 * commercial use.  Commercial use includes (1) integration of all or       *
 * part of the source code into a product for sale or license by or on      *
 * behalf of Licensee to third parties, or (2) distribution of the binary   *
 * code or source code to third parties that need it to utilize a           *
 * commercial product sold or licensed by or on behalf of Licensee.         *
 *                                                                          *
 * UI MAKES NO REPRESENTATIONS ABOUT THE SUITABILITY OF THIS SOFTWARE FOR   *
 * ANY PURPOSE.  IT IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED          *
 * WARRANTY.  THE UI SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY THE    *
 * USERS OF THIS SOFTWARE.                                                  *
 *                                                                          *
 * By using or copying this Software, Licensee agrees to abide by the       *
 * copyright law and all other applicable laws of the U.S. including, but   *
 * not limited to, export control laws, and the terms of this license.      *
 * UI shall have the right to terminate this license immediately by         *
 * written notice upon Licensee's breach of, or non-compliance with, any    *
 * of its terms.  Licensee may be held legally responsible for any          *
 * copyright infringement that is caused or encouraged by Licensee's        *
 * failure to abide by the terms of this license.                           *
 *                                                                          *
 * Comments and questions are welcome and can be sent to                    *
 * mosaic-x@ncsa.uiuc.edu.                                                  *
 ****************************************************************************/

#ifndef __PIXMAPS_H__
#define __PIXMAPS_H__

#include "pixmaps/icon.1.xpm"
#include "pixmaps/icon.2.xpm"
#include "pixmaps/icon.3.xpm"
#include "pixmaps/icon.4.xpm"
#include "pixmaps/icon.5.xpm"
#include "pixmaps/icon.6.xpm"
#include "pixmaps/icon.7.xpm"
#include "pixmaps/icon.8.xpm"
#include "pixmaps/icon.9.xpm"
#include "pixmaps/icon.10.xpm"
#include "pixmaps/icon.11.xpm"
#include "pixmaps/icon.12.xpm"
#include "pixmaps/icon.13.xpm"
#include "pixmaps/icon.14.xpm"
#include "pixmaps/icon.15.xpm"
#include "pixmaps/icon.16.xpm"
#include "pixmaps/icon.17.xpm"
#include "pixmaps/icon.18.xpm"
#include "pixmaps/icon.19.xpm"
#include "pixmaps/icon.20.xpm"
#include "pixmaps/icon.21.xpm"
#include "pixmaps/icon.22.xpm"
#include "pixmaps/icon.23.xpm"
#include "pixmaps/icon.24.xpm"
#include "pixmaps/icon.25.xpm"

#include "pixmaps/s_icon.1.xpm"
#include "pixmaps/s_icon.2.xpm"
#include "pixmaps/s_icon.3.xpm"
#include "pixmaps/s_icon.4.xpm"
#include "pixmaps/s_icon.5.xpm"
#include "pixmaps/s_icon.6.xpm"
#include "pixmaps/s_icon.7.xpm"
#include "pixmaps/s_icon.8.xpm"
#include "pixmaps/s_icon.9.xpm"
#include "pixmaps/s_icon.10.xpm"
#include "pixmaps/s_icon.11.xpm"
#include "pixmaps/s_icon.12.xpm"
#include "pixmaps/s_icon.13.xpm"
#include "pixmaps/s_icon.14.xpm"
#include "pixmaps/s_icon.15.xpm"
#include "pixmaps/s_icon.16.xpm"
#include "pixmaps/s_icon.17.xpm"
#include "pixmaps/s_icon.18.xpm"
#include "pixmaps/s_icon.19.xpm"
#include "pixmaps/s_icon.20.xpm"
#include "pixmaps/s_icon.21.xpm"
#include "pixmaps/s_icon.22.xpm"
#include "pixmaps/s_icon.23.xpm"
#include "pixmaps/s_icon.24.xpm"
#include "pixmaps/s_icon.25.xpm"

#include "pixmaps/mag.1.xpm"
#include "pixmaps/mag.2.xpm"
#include "pixmaps/mag.3.xpm"
#include "pixmaps/mag.4.xpm"
#include "pixmaps/mag.5.xpm"
#include "pixmaps/mag.6.xpm"
#include "pixmaps/mag.7.xpm"
#include "pixmaps/mag.8.xpm"
#include "pixmaps/mag.9.xpm"
#include "pixmaps/mag.10.xpm"
#include "pixmaps/mag.11.xpm"
#include "pixmaps/mag.12.xpm"
#include "pixmaps/mag.13.xpm"
#include "pixmaps/mag.14.xpm"
#include "pixmaps/mag.15.xpm"
#include "pixmaps/mag.16.xpm"
#include "pixmaps/mag.17.xpm"
#include "pixmaps/mag.18.xpm"
#include "pixmaps/mag.19.xpm"
#include "pixmaps/mag.20.xpm"
#include "pixmaps/mag.21.xpm"

#include "pixmaps/unlock_none.xpm"
#include "pixmaps/unlock_unknown.xpm"
#include "pixmaps/lock_md5.xpm"
#include "pixmaps/lock_kerberos4.xpm"
#include "pixmaps/lock_kerberos5.xpm"
#include "pixmaps/lock_basic.xpm"
#include "pixmaps/lock_domain.xpm"
#include "pixmaps/lock_login.xpm"

#include "pixmaps/xm_error.xpm"
#include "pixmaps/xm_information.xpm"
#include "pixmaps/xm_question.xpm"
#include "pixmaps/xm_warning.xpm"

#include "pixmaps/toolbar_save_1.xpm"
#include "pixmaps/toolbar_ftp_put_1.xpm"
#include "pixmaps/toolbar_ftp_mkdir_1.xpm"
#include "pixmaps/toolbar_back_1.xpm"
#include "pixmaps/toolbar_forw_1.xpm"
#include "pixmaps/toolbar_open_1.xpm"
#include "pixmaps/toolbar_reload_1.xpm"
#include "pixmaps/toolbar_print_1.xpm"
#include "pixmaps/toolbar_news_list_1.xpm"
#include "pixmaps/toolbar_news_groups_1.xpm"
#include "pixmaps/toolbar_search_1.xpm"
#include "pixmaps/toolbar_home_1.xpm"
#include "pixmaps/toolbar_post_1.xpm"
#include "pixmaps/toolbar_followup_1.xpm"
#include "pixmaps/toolbar_next_art_1.xpm"
#include "pixmaps/toolbar_next_thr_1.xpm"
#include "pixmaps/toolbar_prev_art_1.xpm"
#include "pixmaps/toolbar_prev_thr_1.xpm"
#include "pixmaps/toolbar_open_window_1.xpm"
#include "pixmaps/toolbar_clone_window_1.xpm"
#include "pixmaps/toolbar_close_window_1.xpm"
#include "pixmaps/toolbar_hotlist_1.xpm"

#include "pixmaps/tearv.xpm"
#include "pixmaps/tearh.xpm"

#include "pixmaps/splash.xpm"
#include "pixmaps/not_secure.xpm"


void AnimatePixmapInWidget(Widget, Pixmap);
void MakeAnimationPixmaps(Widget);
void ReleaseSplashColors(Widget wid);
Pixmap LoadSplashXPM(Widget wid, int *colorcount);
void MakePixmaps(Widget wid);
void DrawSecurityPixmap(Widget wid, Pixmap pix);


#endif
